module EvalPartial where

import Expr

eval :: Expr -> Maybe Double
eval (Var _)  = return 0
eval (Num n)  = return n
eval (Plus a b)  = do x<- eval a; y<- eval b; return $ x+ y
eval (Minus a b) = do x<- eval a; y<- eval b; return $ x- y
eval (Times a b) = do x<- eval a; y<- eval b; return $ x* y
eval (Div a b)   = do
  x<- eval a; y<- eval b; if y == 0 then Nothing else Just $ x/ y

{-
-- Examples:
eval (Plus (Num 3) (Div (Times (Num 4) (Num 5)) (Minus (Num 3) (Num 3))))
eval (Plus (Num 3) (Div (Times (Num 4) (Num 5)) (Minus (Num 4) (Num 3))))

-}
